package com.aircraft.modules.system.service;

import com.aircraft.modules.system.domain.EmArea;
import com.aircraft.utils.PageResult;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author cli
 * @since 2025-07-09
 */
public interface EmAreaService extends IService<EmArea> {

    /**
     * 条件查询
     * @param example
     * @return
     */
    List<EmArea> list(EmArea example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    PageResult<EmArea> page(EmArea example, IPage page);

    /**
     * 根据名称获取区域
     * @param name
     * @return
     */
    EmArea findByName(String name);

    /**
     * 区域景区数量重置
     */
    @Transactional
    void setAreaScenicNumToZero();

    /**
     * 批量根据id获取
     * @param collect
     * @return
     */
    List<EmArea> findByIdIn(List<Integer> collect);

    Map<Long, String> getNameMapByIds(List<Long> regionIds);

    EmArea findById(Long areaId);
}
